#include <iostream>
#include <thread>
#include <mutex>

int shared_value = 0;
std::mutex mtx;

void increment(int id) {
    for (int i = 0; i < 1000; ++i) {
        std::lock_guard<std::mutex> lock(mtx);
        ++shared_value;
        std::cout << "Thread " << id << " incremented value to " << shared_value << std::endl;
    }
}

int main() {
    std::thread t1(increment, 1);
    std::thread t2(increment, 2);

    t1.join();
    t2.join();

    std::cout << "Final value: " << shared_value << std::endl;
    return 0;
}
